
// Raccatto i parametri dall'URL -- mi aspetto un parametro di nome 'link'!
thisUrlParams = {};
window.location.href.replace(/[?&]+([^=&]+)=([^&]*)/gi, function(m,key,value) {
    thisUrlParams[key] = value;
});
console.log('URL get params: ', thisUrlParams.params);

var params = thisUrlParams.params;
const pp = params.split(";");
var tipo = pp[0];


prefixes = queryManager['prefixes']['all'];

if (tipo=="lemma") {
    var uri_lemma = pp[1];
    var lemma = pp[2].replace(/%20/g, " ");;
    queryEsplora = prefixes + (queryManager['queryRES']['queryEsploraDocumenti']).replaceAll('{URI}', uri_lemma);
    queryMappa = prefixes + (queryManager['queryRES']['queryEsploraMappa']).replaceAll('{LEMMA}', uri_lemma);
    doJsonQuery(queryEsplora).done(function(r) { handleLemma(r, lemma); });
    doJsonQuery(queryMappa).done(function(r) { handle_map(r); });
}

if (tipo=="lettera") {
    var uri_mittente = pp[2];
    var uri_destinatario = pp[4];
    var mittente = pp[1].replace(/%20/g, " ");
    var destinatario = pp[3].replace(/%20/g, " ");
    queryLettere = prefixes + (queryManager['queryRES']['queryExchange']).replace('{MITTENTE}', uri_mittente).replace('{DESTINATARIO}', uri_destinatario);
    doJsonQuery(queryLettere).done(function(r) { handle_Letters(r, mittente, destinatario); });

}


function prepareQueryURL(query){
    sparqlEndpoint = 'http://dev.restore.ovi.cnr.it:8890/sparql/';
    sparqlUrlParams = '?default-graph-uri=&query=' + encodeURIComponent(query) + '&output=json&callback=?';
    return sparqlEndpoint + sparqlUrlParams;
}

function doJsonQuery(query) {
	
	queryURL = prepareQueryURL(query);
	return $.ajax({
		url: queryURL,
        dataType: "json",
		type: 'GET'
    });
}

// Funzioni per raccattare + stringhificare l'output
queryStringOutput = "";
function stringifyResponse(val){
    resultArray = val['results']['bindings'];
    out = "";
    for(i = 0; i < resultArray.length; i++){
        out = out + JSON.stringify(resultArray[i])
    }
    queryStringOutput = (queryStringOutput + out).replace("}{",",");
}

////////////////////
// TESTI DELLE QUERY
////////////////////
	

/*prefixes = "PREFIX rdfs: <http://www.w3.org/2000/01/rdf-schema#> \
PREFIX rdf: <http://www.w3.org/1999/02/22-rdf-syntax-ns#> \
PREFIX crm: <http://www.cidoc-crm.org/cidoc-crm/> \
PREFIX dat: <http://datini.archiviodistato.prato.it/la-ricerca/scheda/> \
PREFIX mpp: <http://palazzopretorio.comune.prato.it/it/le-opere/alcuni-capolavori/> \
PREFIX aut: <http://palazzopretorio.comune.prato.it/it/opere/autori/>"

queryLettere = prefixes + " SELECT DISTINCT ?uri_document ?document ?time_span_from ?time_span_to ?uri_place_from ?place_from ?uri_place_to ?place_to \
{ \
?event_from rdfs:subClassOf ?event ; \
rdf:type crm:EL2_Send_Letter . \
?event_to rdfs:subClassOf ?event ; \
rdf:type crm:EL3_Receive_Letter . \
\
?event_from crm:P01_has_domain ?pc_from . \
?pc_from crm:P02_has_range <" + uri_mittente + "> . \
OPTIONAL {?event_from crm:P4_has_time-span ?uri_time_span_from . \
?uri_time_span_from rdfs:label ?time_span_from} \
OPTIONAL {?event_from crm:P27_moved_from ?aspo_place_from . \
?aspo_place_from owl:sameAs ?uri_place_from . \
?uri_place_from rdfs:label ?place_from ; \
crm:P168_place_is_defined_by ?coords_from} \
\
?event_to crm:P01_has_domain ?pc_to . \
?pc_to crm:P02_has_range <" + uri_destinatario + "> . \
OPTIONAL {?event_to crm:P4_has_time-span ?uri_time_span_to . \
?uri_time_span_to rdfs:label ?time_span_to} \
OPTIONAL {?event_to crm:P26_moved_to ?aspo_place_to . \
?aspo_place_to owl:sameAs ?uri_place_to . \
?uri_place_to rdfs:label ?place_to ; \
crm:P168_place_is_defined_by ?coords_to} \
\
?uri_document crm:P25i_moved_by ?event ; \
rdfs:label ?document . \
}"*/

